Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3597)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3600)
@@ -1074,89 +1090,90 @@
 !> Check parameters routine for chemistry_model_mod
 !------------------------------------------------------------------------------!
-    SUBROUTINE chem_check_parameters
-
-       IMPLICIT NONE
-
-       LOGICAL                        ::  found
-       INTEGER (iwp)                  ::  lsp_usr      !< running index for user defined chem spcs 
-       INTEGER (iwp)                  ::  lsp          !< running index for chem spcs.
-
-
-!!--   check for chemical reactions status
-       IF ( chem_gasphase_on )  THEN
-          message_string = 'Chemical reactions: ON'
-          CALL message( 'chem_check_parameters', 'CM0421', 0, 0, 0, 6, 0 )
-       ELSEIF ( .not. (chem_gasphase_on) ) THEN
-          message_string = 'Chemical reactions: OFF'
-          CALL message( 'chem_check_parameters', 'CM0422', 0, 0, 0, 6, 0 )
+ SUBROUTINE chem_check_parameters
+
+    IMPLICIT NONE
+
+    LOGICAL       ::  found
+    INTEGER (iwp) ::  lsp_usr      !< running index for user defined chem spcs 
+    INTEGER (iwp) ::  lsp          !< running index for chem spcs.
+
+
+!
+!-- check for chemical reactions status
+    IF ( chem_gasphase_on )  THEN
+       message_string = 'Chemical reactions: ON'
+       CALL message( 'chem_check_parameters', 'CM0421', 0, 0, 0, 6, 0 )
+    ELSEIF ( .not. (chem_gasphase_on) ) THEN
+       message_string = 'Chemical reactions: OFF'
+       CALL message( 'chem_check_parameters', 'CM0422', 0, 0, 0, 6, 0 )
+    ENDIF
+
+!-- check for chemistry time-step
+    IF ( call_chem_at_all_substeps )  THEN
+       message_string = 'Chemistry is calculated at all meteorology time-step'
+       CALL message( 'chem_check_parameters', 'CM0423', 0, 0, 0, 6, 0 )
+    ELSEIF ( .not. (call_chem_at_all_substeps) ) THEN
+       message_string = 'Sub-time-steps are skipped for chemistry time-steps'
+       CALL message( 'chem_check_parameters', 'CM0424', 0, 0, 0, 6, 0 )
+    ENDIF
+
+!-- check for photolysis scheme 
+    IF ( (photolysis_scheme /= 'simple') .AND. (photolysis_scheme /= 'constant')  )  THEN
+       message_string = 'Incorrect photolysis scheme selected, please check spelling'
+       CALL message( 'chem_check_parameters', 'CM0425', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!-- check for  decycling of chem species
+    IF ( (.not. any(decycle_method == 'neumann') ) .AND. (.not. any(decycle_method == 'dirichlet') ) )   THEN
+       message_string = 'Incorrect boundary conditions. Only neumann or '   &
+                // 'dirichlet &available for decycling chemical species '
+       CALL message( 'chem_check_parameters', 'CM0426', 1, 2, 0, 6, 0 )
+    ENDIF
+
+!---------------------
+!-- chem_check_parameters is called before the array chem_species is allocated!
+!-- temporary switch of this part of the check
+    RETURN
+!---------------------
+
+!-- check for initial chem species input
+    lsp_usr = 1
+    lsp     = 1
+    DO WHILE ( cs_name (lsp_usr) /= 'novalue')
+       found = .FALSE.
+       DO lsp = 1, nvar
+          IF ( TRIM(cs_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
+             found = .TRUE.
+             EXIT
+          ENDIF 
+       ENDDO
+       IF ( .not. found ) THEN
+          message_string = 'Unused/incorrect input for initial surface value: ' // TRIM(cs_name(lsp_usr))
+          CALL message( 'chem_check_parameters', 'CM0427', 0, 1, 0, 6, 0 )
        ENDIF
-
-!--    check for chemistry time-step
-       IF ( call_chem_at_all_substeps )  THEN
-          message_string = 'Chemistry is calculated at all meteorology time-step'
-          CALL message( 'chem_check_parameters', 'CM0423', 0, 0, 0, 6, 0 )
-       ELSEIF ( .not. (call_chem_at_all_substeps) ) THEN
-          message_string = 'Sub-time-steps are skipped for chemistry time-steps'
-          CALL message( 'chem_check_parameters', 'CM0424', 0, 0, 0, 6, 0 )
+       lsp_usr = lsp_usr + 1
+    ENDDO
+
+!-- check for surface  emission flux chem species
+
+    lsp_usr = 1
+    lsp     = 1
+    DO WHILE ( surface_csflux_name (lsp_usr) /= 'novalue')
+       found = .FALSE.
+       DO lsp = 1, nvar
+          IF ( TRIM(surface_csflux_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
+             found = .TRUE.
+             EXIT
+          ENDIF 
+       ENDDO
+       IF ( .not. found ) THEN
+          message_string = 'Unused/incorrect input of chemical species for surface emission fluxes: '  &
+                            // TRIM(surface_csflux_name(lsp_usr))
+          CALL message( 'chem_check_parameters', 'CM0428', 0, 1, 0, 6, 0 )
        ENDIF
-
-!--    check for photolysis scheme 
-       IF ( (photolysis_scheme /= 'simple') .AND. (photolysis_scheme /= 'constant')  )  THEN
-          message_string = 'Incorrect photolysis scheme selected, please check spelling'
-          CALL message( 'chem_check_parameters', 'CM0425', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!--    check for  decycling of chem species
-       IF ( (.not. any(decycle_method == 'neumann') ) .AND. (.not. any(decycle_method == 'dirichlet') ) )   THEN
-          message_string = 'Incorrect boundary conditions. Only neumann or '   &
-                   // 'dirichlet &available for decycling chemical species '
-          CALL message( 'chem_check_parameters', 'CM0426', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!---------------------
-!--    chem_check_parameters is called before the array chem_species is allocated!
-!--    temporary switch of this part of the check
-       RETURN
-!---------------------
-
-!--    check for initial chem species input
-       lsp_usr = 1
-       lsp     = 1
-       DO WHILE ( cs_name (lsp_usr) /= 'novalue')
-          found = .FALSE.
-          DO lsp = 1, nvar
-             IF ( TRIM(cs_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
-                found = .TRUE.
-                EXIT
-             ENDIF 
-          ENDDO
-          IF ( .not. found ) THEN
-             message_string = 'Incorrect input for initial surface vaue: ' // TRIM(cs_name(lsp_usr))
-             CALL message( 'chem_check_parameters', 'CM0427', 0, 1, 0, 6, 0 )
-          ENDIF
-          lsp_usr = lsp_usr + 1
-       ENDDO
-
-!--    check for surface  emission flux chem species
-
-       lsp_usr = 1
-       lsp     = 1
-       DO WHILE ( surface_csflux_name (lsp_usr) /= 'novalue')
-          found = .FALSE.
-          DO lsp = 1, nvar
-             IF ( TRIM(surface_csflux_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
-                found = .TRUE.
-                EXIT
-             ENDIF 
-          ENDDO
-          IF ( .not. found ) THEN
-             message_string = 'Incorrect input of chemical species for surface emission fluxes: '  &
-                               // TRIM(surface_csflux_name(lsp_usr))
-             CALL message( 'chem_check_parameters', 'CM0428', 0, 1, 0, 6, 0 )
-          ENDIF
-          lsp_usr = lsp_usr + 1
-       ENDDO
-
-    END SUBROUTINE chem_check_parameters
+       lsp_usr = lsp_usr + 1
+    ENDDO
+
+ END SUBROUTINE chem_check_parameters
 
 !
@@ -1169,81 +1186,83 @@
 !------------------------------------------------------------------------------!
     
-    SUBROUTINE chem_data_output_2d( av, variable, found, grid, mode, local_pf,   &
-                                     two_d, nzb_do, nzt_do, fill_value )
-    
-       USE indices
-
-       USE kinds
-
-       USE pegrid,             ONLY: myid, threads_per_task
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  grid       !<
-       CHARACTER (LEN=*) ::  mode       !< 
-       CHARACTER (LEN=*) ::  variable   !< 
-       INTEGER(iwp) ::  av              !< flag to control data output of instantaneous or time-averaged data
-       INTEGER(iwp) ::  nzb_do          !< lower limit of the domain (usually nzb)
-       INTEGER(iwp) ::  nzt_do          !< upper limit of the domain (usually nzt+1)
-       LOGICAL      ::  found           !< 
-       LOGICAL      ::  two_d           !< flag parameter that indicates 2D variables (horizontal cross sections)
-       REAL(wp)     ::  fill_value 
-       REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< 
-
-       !-- local variables.
-       CHARACTER(len=16)    ::  spec_name
-       INTEGER(iwp) ::  lsp
-       INTEGER(iwp) ::  i               !< grid index along x-direction
-       INTEGER(iwp) ::  j               !< grid index along y-direction
-       INTEGER(iwp) ::  k               !< grid index along z-direction
-       INTEGER(iwp) ::  m               !< running index surface elements
-       INTEGER(iwp) ::  char_len        !< length of a character string
-       found = .TRUE.
-       char_len  = LEN_TRIM(variable)
-
-       spec_name = TRIM( variable(4:char_len-3) )
-
-          DO lsp=1,nspec
-             IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name)    .AND.                             &
-                   ( (variable(char_len-2:) == '_xy')               .OR.                              &
-                     (variable(char_len-2:) == '_xz')               .OR.                              &
-                     (variable(char_len-2:) == '_yz') ) )               THEN             
+ SUBROUTINE chem_data_output_2d( av, variable, found, grid, mode, local_pf,   &
+                                  two_d, nzb_do, nzt_do, fill_value )
+
+    USE indices
+
+    USE kinds
+
+    USE pegrid,                                                               &
+        ONLY:  myid, threads_per_task
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  grid       !<
+    CHARACTER (LEN=*) ::  mode       !< 
+    CHARACTER (LEN=*) ::  variable   !< 
+    INTEGER(iwp) ::  av              !< flag to control data output of instantaneous or time-averaged data
+    INTEGER(iwp) ::  nzb_do          !< lower limit of the domain (usually nzb)
+    INTEGER(iwp) ::  nzt_do          !< upper limit of the domain (usually nzt+1)
+    LOGICAL      ::  found           !< 
+    LOGICAL      ::  two_d           !< flag parameter that indicates 2D variables (horizontal cross sections)
+    REAL(wp)     ::  fill_value 
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< 
+
+    !
+    !-- local variables.
+    CHARACTER(len=16)    ::  spec_name
+    INTEGER(iwp) ::  lsp
+    INTEGER(iwp) ::  i               !< grid index along x-direction
+    INTEGER(iwp) ::  j               !< grid index along y-direction
+    INTEGER(iwp) ::  k               !< grid index along z-direction
+    INTEGER(iwp) ::  m               !< running index surface elements
+    INTEGER(iwp) ::  char_len        !< length of a character string
+    found = .TRUE.
+    char_len  = LEN_TRIM(variable)
+
+    spec_name = TRIM( variable(4:char_len-3) )
+
+       DO lsp=1,nspec
+          IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name)    .AND.                             &
+                ( (variable(char_len-2:) == '_xy')               .OR.                              &
+                  (variable(char_len-2:) == '_xz')               .OR.                              &
+                  (variable(char_len-2:) == '_yz') ) )               THEN             
 !
 !--   todo: remove or replace by "CALL message" mechanism (kanani)
 !                    IF(myid == 0)  WRITE(6,*) 'Output of species ' // TRIM(variable)  //               &
 !                                                             TRIM(chem_species(lsp)%name)       
-                IF (av == 0) THEN
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         DO  k = nzb_do, nzt_do
-                              local_pf(i,j,k) = MERGE(                                                &
-                                                 chem_species(lsp)%conc(k,j,i),                       &
-                                                 REAL( fill_value, KIND = wp ),                       &
-                                                 BTEST( wall_flags_0(k,j,i), 0 ) )
-
-
-                         ENDDO
+             IF (av == 0) THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                           local_pf(i,j,k) = MERGE(                                                &
+                                              chem_species(lsp)%conc(k,j,i),                       &
+                                              REAL( fill_value, KIND = wp ),                       &
+                                              BTEST( wall_flags_0(k,j,i), 0 ) )
+
+
                       ENDDO
                    ENDDO
-              
-                ELSE
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         DO  k = nzb_do, nzt_do
-                              local_pf(i,j,k) = MERGE(                                                &
-                                                 chem_species(lsp)%conc_av(k,j,i),                    &
-                                                 REAL( fill_value, KIND = wp ),                       &
-                                                 BTEST( wall_flags_0(k,j,i), 0 ) )
-                         ENDDO
+                ENDDO
+
+             ELSE
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb_do, nzt_do
+                           local_pf(i,j,k) = MERGE(                                                &
+                                              chem_species(lsp)%conc_av(k,j,i),                    &
+                                              REAL( fill_value, KIND = wp ),                       &
+                                              BTEST( wall_flags_0(k,j,i), 0 ) )
                       ENDDO
                    ENDDO
-                ENDIF
-                 grid = 'zu'           
+                ENDDO
              ENDIF
-          ENDDO
-
-          RETURN
-     
-    END SUBROUTINE chem_data_output_2d      
+              grid = 'zu'           
+          ENDIF
+       ENDDO
+
+       RETURN
+
+ END SUBROUTINE chem_data_output_2d      
 
 !
@@ -1255,108 +1274,112 @@
 !------------------------------------------------------------------------------!
 
-    SUBROUTINE chem_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
-
-
-       USE indices
-
-       USE kinds
-
-       USE surface_mod
-
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*)    ::  variable     !<
-       INTEGER(iwp)         ::  av           !<
-       INTEGER(iwp) ::  nzb_do               !< lower limit of the data output (usually 0)
-       INTEGER(iwp) ::  nzt_do               !< vertical upper limit of the data output (usually nz_do3d)
-
-       LOGICAL      ::  found                !<
-
-       REAL(wp)             ::  fill_value !<
-       REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf 
-
-
-       !-- local variables
-       CHARACTER(len=16)    ::  spec_name
-       INTEGER(iwp)         ::  i, j, k
-       INTEGER(iwp)         ::  m, l    !< running indices for surfaces
-       INTEGER(iwp)         ::  lsp  !< running index for chem spcs
-
-
-       found = .FALSE.
-       IF ( .NOT. (variable(1:3) == 'kc_' .OR. variable(1:3) == 'em_' ) ) THEN
-          RETURN
-       ENDIF
-
-       spec_name = TRIM(variable(4:))
-
-       IF ( variable(1:3) == 'em_' ) THEN
-
-         local_pf = 0.0_wp
-
-         DO lsp = 1, nvar  !!! cssws - nvar species, chem_species - nspec species !!!
-            IF ( TRIM(spec_name) == TRIM(chem_species(lsp)%name) )   THEN
-               ! no average for now
-               DO m = 1, surf_usm_h%ns
-                  local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) = &
-                     local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) + surf_usm_h%cssws(lsp,m)
+ SUBROUTINE chem_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
+
+
+    USE indices
+
+    USE kinds
+
+    USE surface_mod
+
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*)    ::  variable     !<
+    INTEGER(iwp)         ::  av           !<
+    INTEGER(iwp) ::  nzb_do               !< lower limit of the data output (usually 0)
+    INTEGER(iwp) ::  nzt_do               !< vertical upper limit of the data output (usually nz_do3d)
+
+    LOGICAL      ::  found                !<
+
+    REAL(wp)             ::  fill_value   !<
+    REAL(sp), DIMENSION(nxl:nxr, nys:nyn, nzb_do:nzt_do) ::  local_pf 
+
+
+    !-- local variables
+    CHARACTER(len=16)    ::  spec_name
+    INTEGER(iwp)         ::  i
+    INTEGER(iwp)         ::  j
+    INTEGER(iwp)         ::  k
+    INTEGER(iwp)         ::  m       !< running indices for surfaces
+    INTEGER(iwp)         ::  l
+    INTEGER(iwp)         ::  lsp     !< running index for chem spcs
+
+
+    found = .FALSE.
+    IF ( .NOT. (variable(1:3) == 'kc_' .OR. variable(1:3) == 'em_' ) ) THEN
+       RETURN
+    ENDIF
+
+    spec_name = TRIM(variable(4:))
+
+    IF ( variable(1:3) == 'em_' ) THEN
+
+      local_pf = 0.0_wp
+
+      DO lsp = 1, nvar   !!! cssws - nvar species, chem_species - nspec species !!!
+         IF ( TRIM(spec_name) == TRIM(chem_species(lsp)%name) )   THEN
+            !
+            !-- no average for now
+            DO m = 1, surf_usm_h%ns
+               local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) = &
+                  local_pf(surf_usm_h%i(m),surf_usm_h%j(m),surf_usm_h%k(m)) + surf_usm_h%cssws(lsp,m)
+            ENDDO
+            DO m = 1, surf_lsm_h%ns
+               local_pf(surf_lsm_h%i(m),surf_lsm_h%j(m),surf_lsm_h%k(m)) = &
+                  local_pf(surf_lsm_h%i(m),surf_lsm_h%j(m),surf_lsm_h%k(m)) + surf_lsm_h%cssws(lsp,m)
+            ENDDO
+            DO l = 0, 3
+               DO m = 1, surf_usm_v(l)%ns
+                  local_pf(surf_usm_v(l)%i(m),surf_usm_v(l)%j(m),surf_usm_v(l)%k(m)) = &
+                     local_pf(surf_usm_v(l)%i(m),surf_usm_v(l)%j(m),surf_usm_v(l)%k(m)) + surf_usm_v(l)%cssws(lsp,m)
                ENDDO
-               DO m = 1, surf_lsm_h%ns
-                  local_pf(surf_lsm_h%i(m),surf_lsm_h%j(m),surf_lsm_h%k(m)) = &
-                     local_pf(surf_lsm_h%i(m),surf_lsm_h%j(m),surf_lsm_h%k(m)) + surf_lsm_h%cssws(lsp,m)
+               DO m = 1, surf_lsm_v(l)%ns
+                  local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) = &
+                     local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) + surf_lsm_v(l)%cssws(lsp,m)
                ENDDO
-               DO l = 0, 3
-                  DO m = 1, surf_usm_v(l)%ns
-                     local_pf(surf_usm_v(l)%i(m),surf_usm_v(l)%j(m),surf_usm_v(l)%k(m)) = &
-                        local_pf(surf_usm_v(l)%i(m),surf_usm_v(l)%j(m),surf_usm_v(l)%k(m)) + surf_usm_v(l)%cssws(lsp,m)
-                  ENDDO
-                  DO m = 1, surf_lsm_v(l)%ns
-                     local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) = &
-                        local_pf(surf_lsm_v(l)%i(m),surf_lsm_v(l)%j(m),surf_lsm_v(l)%k(m)) + surf_lsm_v(l)%cssws(lsp,m)
-                  ENDDO
-               ENDDO
-               found = .TRUE.
-            ENDIF
-         ENDDO
-       ELSE
-         DO lsp=1,nspec
-            IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
+            ENDDO
+            found = .TRUE.
+         ENDIF
+      ENDDO
+    ELSE
+      DO lsp=1,nspec
+         IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
 !
 !--   todo: remove or replace by "CALL message" mechanism (kanani)
 !              IF(myid == 0 .AND. chem_debug0 )  WRITE(6,*) 'Output of species ' // TRIM(variable)  //  &
 !                                                           TRIM(chem_species(lsp)%name)       
-               IF (av == 0) THEN
-                  DO  i = nxl, nxr
-                     DO  j = nys, nyn
-                        DO  k = nzb_do, nzt_do
-                            local_pf(i,j,k) = MERGE(                             &
-                                                chem_species(lsp)%conc(k,j,i),   &
-                                                REAL( fill_value, KIND = wp ),   &
-                                                BTEST( wall_flags_0(k,j,i), 0 ) )
-                        ENDDO
+            IF (av == 0) THEN
+               DO  i = nxl, nxr
+                  DO  j = nys, nyn
+                     DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE(                             &
+                                             chem_species(lsp)%conc(k,j,i),   &
+                                             REAL( fill_value, KIND = wp ),   &
+                                             BTEST( wall_flags_0(k,j,i), 0 ) )
                      ENDDO
                   ENDDO
-
-               ELSE
-                  DO  i = nxl, nxr
-                     DO  j = nys, nyn
-                        DO  k = nzb_do, nzt_do
-                            local_pf(i,j,k) = MERGE(                             &
-                                                chem_species(lsp)%conc_av(k,j,i),&
-                                                REAL( fill_value, KIND = wp ),   &
-                                                BTEST( wall_flags_0(k,j,i), 0 ) )
-                        ENDDO
+               ENDDO
+
+            ELSE
+               DO  i = nxl, nxr
+                  DO  j = nys, nyn
+                     DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE(                             &
+                                             chem_species(lsp)%conc_av(k,j,i),&
+                                             REAL( fill_value, KIND = wp ),   &
+                                             BTEST( wall_flags_0(k,j,i), 0 ) )
                      ENDDO
                   ENDDO
-               ENDIF
-               found = .TRUE.
+               ENDDO
             ENDIF
-         ENDDO
-       ENDIF
-
-       RETURN
-
-    END SUBROUTINE chem_data_output_3d
+            found = .TRUE.
+         ENDIF
+      ENDDO
+    ENDIF
+
+    RETURN
+
+ END SUBROUTINE chem_data_output_3d
 !
 !------------------------------------------------------------------------------!
